// StandardFieldsMessage.cc

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "Message.h"
#include "StandardFieldsMessage.h"

int32 StandardFieldsMessage:: toBuffer(char **buffer) const
{
    int32 nbytes;

    nbytes = Message::toBuffer(buffer);
    nbytes += MPF::toBuffer(buffer,timeoutUnits);
    nbytes += MPF::toBuffer(buffer,timeout);
    nbytes += MPF::toBuffer(buffer,cmd);
    nbytes += MPF::toBuffer(buffer,status);
    nbytes += MPF::toBuffer(buffer,address);
    nbytes += MPF::toBuffer(buffer,extra);
    return(nbytes);
}

int32 StandardFieldsMessage:: fromBuffer(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&timeoutUnits);
    nbytes += MPF::fromBuffer(buffer,&timeout);
    nbytes += MPF::fromBuffer(buffer,&cmd);
    nbytes += MPF::fromBuffer(buffer,&status);
    nbytes += MPF::fromBuffer(buffer,&address);
    nbytes += MPF::fromBuffer(buffer,&extra);
    return(nbytes);
}

int32 StandardFieldsMessage:: fromBufferSwitch(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    nbytes += MPF::fromBufferSwitch(buffer,&timeoutUnits);
    nbytes += MPF::fromBufferSwitch(buffer,&timeout);
    nbytes += MPF::fromBufferSwitch(buffer,&cmd);
    nbytes += MPF::fromBufferSwitch(buffer,&status);
    nbytes += MPF::fromBufferSwitch(buffer,&address);
    nbytes += MPF::fromBufferSwitch(buffer,&extra);
    return(nbytes);
}

static char *timeoutUnitsString[3] =
{"seconds","milliseconds","unknown"};

void StandardFieldsMessage:: print() const
{
    Message::print();
    int ind = (timeoutUnits<=1 ? timeoutUnits : 2);
    printf("  timeout %u %s\n",timeout,timeoutUnitsString[ind]);
    printf("      cmd %u\n",cmd);
    printf("   status %d\n",status);
    printf("  address %d\n",address);
    printf("    extra %d\n",cmd);
}
